/***************************************************************
 Reconstitution graphique d'un tachymetre Flaman
       adapté au wagon de mesure  
       
 S.G.  V1.0    21/12/2019
****************************************************************/

PImage fond;              // image de fond du tachymetre a lire dans ./data
PImage cadran;            // image des graduations
PImage top;               // image du dessus
PImage bouton_on;         // image interrupteur sur ON
PImage bouton_off;        // image interrupteur sur OFF
PImage aiguille_rouge, aiguille_noire, aiguille_bleue;  // image des aiguilles a lire dans ./data
PImage aiguille_minutes;  // image de l'aiguille des minutes a lire dans ./data
PImage wagon;             // icone pour le titre, a lire dans ./data

PFont fontDist;           // font utilisee pour la distance (ici ce sera 7 segments)
PFont fontUnits;          // font pour les unites sur le cadran
PFont fontDymo;           // font pour les boutons
PFont fontInfo;           // font pour la trame recue

int Dx, Dy, Dl, Dh;       // position texte distance  segments
int Vx, Vy;               // coordonnees du tete des unites de vitesse 
int P0, P200;             // angles min et max de l'aiguille (dans l'image, l'aiguille est à -135°)
int WinLarg = 650;        // Largeur de la fenetre  &  WinHaut = taille de l'image  950
int WinHaut = 1050;       // Hauteur de la fenetre
int Xpos,Ypos;            // position initiale du compteur
int distance, vitesse;    // valeurs numeriques recues a afficher
int X0,Y0;                // coordonnées centre cadran
int XM,YM;                // centre cadran minutes
float X1,X2,Y1,Y2;        // coins du carré de la zone de click pour le retour de l'aiguille rouge
float Angle,Amax;         // angles des aiguilles

String Ud = "mm";         // unité des distances par defaut
String Uv = "mm/s";       // unité des vitessses par defaut
String trame = "en attente de reception";   // trame recue

ArrayList<Switch> interrupteurs = new ArrayList<Switch>();

void settings() {                   // selection de la taille de la zone dev trace
  WinLarg = displayWidth;
  WinHaut = displayHeight; 
  size (WinLarg,WinHaut,OPENGL);                    // preparation de la fenetre
}

void setup() { 
  float Agrandissement;       // echelle de l'image de fond
 
    orientation(PORTRAIT);
    background(65,160,146);
    
// initialisation Bluetooth     
    setup_BT();
     
 // initialisation des images 
    fond = loadImage("fond.png");                            // image du fond  725x1050
    cadran = loadImage("cadran.png");                        // image des graduations  1038x602
    top = loadImage("top.png");                              // image du dessus  725x1001
    bouton_on = loadImage("bouton_on.png");                  // image du bouton on  106x170
    bouton_off = loadImage("bouton_off.png");                // image du bouton of  106x170
    wagon = loadImage ("Wagon.png");                         // image icon titre  431x303
    aiguille_noire = loadImage("aiguille_noire.png");        // image de l'aiguille noire  535x52
    aiguille_rouge = loadImage("aiguille_rouge.png");        // image de l'aiguille rouge  
    aiguille_bleue = loadImage("aiguille_bleue.png");        // image de l'aiguille bleuee
    aiguille_minutes = loadImage("aiguille_minutes.png");    // image aiguille minutes  137x51
    
 // initialisation des polices de caracteres
           // Uncomment the following two lines to see the available fonts 
           // String[] fontList = PFont.list();
           //  printArray(fontList);
    fontDist = createFont("DSEG7Classic-BoldItalic.ttf", WinLarg*0.06); // pour l'affichage de la distance on utilise 7 segments de taille 40
    fontUnits = createFont("arialbd.ttf",WinLarg*0.025);                // pour l'affichage des unites, on utilise Arial gras de taille 35
    fontDymo = createFont ("Dymo.ttf",WinLarg*0.06);                    // pour affichage des etiquettes des interrupteurs
    fontInfo = createFont("SansSerif", WinLarg*0.03);                   // pour les trames voire le debug

// positions des divers elements (proportionnelles a la largeur de l'ecran)
    Dx=int (WinLarg * 0.89);      // position du texte de la distance
    Dy=int (WinLarg * 0.085);
    Dl=int (WinLarg * 0.355);     // largeur, hauteur du texte de la distance
    Dh=int (WinLarg * 0.08);
    P0=0;  P200=180;              // angles de l'aiguille pour une vitesse de 0 et de 200
    X0=int(WinLarg*0.496);        // centre du cadran des vitesses
    Y0=int(WinLarg*0.655);
    XM=int(WinLarg*0.604);        // centre du cadran des minutes
    YM=int(WinLarg*0.547);
    Xpos=0;
    Ypos=0;
    Vx=X0;
    Vy=int(Y0*0.575);
    X1=WinLarg*0.55+Xpos;
    X2=WinLarg*0.64+Xpos;
    Y1=WinLarg*0.60+Ypos;
    Y2=WinLarg*0.68+Ypos;

    imageMode(CENTER);                                   // images referencees par leur centre
    
    Agrandissement=WinLarg/725.;              // rapport d'échelle largeur ecran / largeur dze l'image de fondAgrandissement=WinLarg/725.;
// instanciation des interrupteurs :
    interrupteurs.add( new Switch(WinLarg/4,(int)(Agrandissement*930), (int)(Agrandissement*60), (int)(Agrandissement*90), bouton_on,bouton_off, 'u', ' ', true));
    interrupteurs.add( new Switch(WinLarg/2,(int)(Agrandissement*930), (int)(Agrandissement*60), (int)(Agrandissement*90), bouton_on,bouton_off, 'r', ' ', true)); 
    interrupteurs.add( new Switch(WinLarg*3/4,(int)(Agrandissement*930), (int)(Agrandissement*60), (int)(Agrandissement*90), bouton_on,bouton_off, 'a', 'e', false)); 
}


void draw() {
  
// Connexion Bluetooth
    if (isConfiguring) {   // au depart l'application cherche à se connecter en BT, il ne faut pas que les graphiques interfererent
      draw_BT();           // appel du draw specifique a l'init du BlueTooth                   
      return;
    }
   
    if (mousePressed) {                 // test de click sur la zone de rappel de l'aiguille rouge               
      if ((mouseX>X1)&&(mouseX<X2) &&
          (mouseY>Y1)&&(mouseY<Y2))  Amax=Angle+(Amax-Angle)*0.95 ; // Rappel de l'aiguille rouge
      else {
      if (mouseY<WinHaut*0.5) {         // test de simulation par la souris
        vitesse = int(map(mouseX, 0,width,-200,200));          // convertion position souris en vitesse
        distance = int(map(mouseY, 0,width,10000,0));          // convertion position souris en valeur affichee
        }
      }
    }
    Angle = radians(map(abs(vitesse), 0,200,P0,P200));   // convertion vitesse en angle aiguille
    if (Angle > Amax) Amax=Angle;                        // valeur max de l'angle pour l'aiguille rouge
    background(65,160,146);           // couleur de fond
    translate(Xpos,Ypos);             // position globale des graphiques par rapport au centre de l'écran
    pushMatrix();                     // repere de tracé de base

    draw_fond();
    
    for (Switch s : interrupteurs) s.Draw();
    
    popMatrix();
    
    println(frameRate);

/*    //                  reperes pour centrage des aiguilles
    pushMatrix();
    translate(X0,Y0);
    stroke(255,0,0);
    line(-400,0,400,0);                   // repere centre cadran principal
    line(0,-400,0,400);
    popMatrix();
    
    pushMatrix();    
    stroke(0,255,0);
    translate(XM,YM);
    //pushMatrix();

    line(-200,0,200,0);                   // repere centre cadran principal
    line(0,-400,0,400);
    popMatrix();
    
    noFill();                            // repere raz aiguille rouge
    stroke (255,255,255);
    rect(X1,Y1,X2-X1,Y2-Y1 );
*/   
}
